searchNodes=[{"doc":"Handles the retrieval of token from Auth0 and their verification/validation.","ref":"PrimaAuth0Ex.html","title":"PrimaAuth0Ex","type":"module"},{"doc":"Force the refresh of the token for a given audience, invalidating both the local and the shared cache.","ref":"PrimaAuth0Ex.html#refresh_token_for/1","title":"PrimaAuth0Ex.refresh_token_for/1","type":"function"},{"doc":"Obtain a token for the given audience.","ref":"PrimaAuth0Ex.html#token_for/1","title":"PrimaAuth0Ex.token_for/1","type":"function"},{"doc":"Verify the integrity of a token, and validate its claims. It is possible to set a list of permissions to validate. Only tokens that include all the required permissions will pass validation. When ignore_signature is true , only checks the validity of claims of the token and not its signature. This option should never be enabled in production-like environments, as it allows anyone to forge valid tokens.","ref":"PrimaAuth0Ex.html#verify_and_validate/4","title":"PrimaAuth0Ex.verify_and_validate/4","type":"function"},{"doc":"Credentials to access Auth0","ref":"PrimaAuth0Ex.Auth0Credentials.html","title":"PrimaAuth0Ex.Auth0Credentials","type":"module"},{"doc":"","ref":"PrimaAuth0Ex.Auth0Credentials.html#from_env/0","title":"PrimaAuth0Ex.Auth0Credentials.from_env/0","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Auth0Credentials.html#t:t/0","title":"PrimaAuth0Ex.Auth0Credentials.t/0","type":"type"},{"doc":"Strategy used by Joken to obtain JWKS from Auth0.","ref":"PrimaAuth0Ex.JwksStrategy.html","title":"PrimaAuth0Ex.JwksStrategy","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. arg is passed as the argument to Task.start_link/1 in the :start field of the spec. For more information, see the Supervisor module, the Supervisor.child_spec/2 function and the Supervisor.child_spec/0 type.","ref":"PrimaAuth0Ex.JwksStrategy.html#child_spec/1","title":"PrimaAuth0Ex.JwksStrategy.child_spec/1","type":"function"},{"doc":"Fetch signers with JokenJwks.HttpFetcher","ref":"PrimaAuth0Ex.JwksStrategy.html#fetch_signers/2","title":"PrimaAuth0Ex.JwksStrategy.fetch_signers/2","type":"function"},{"doc":"Callback for initializing options upon strategy startup","ref":"PrimaAuth0Ex.JwksStrategy.html#init_opts/1","title":"PrimaAuth0Ex.JwksStrategy.init_opts/1","type":"function"},{"doc":"Simple ETS counter based state machine","ref":"PrimaAuth0Ex.JwksStrategy.EtsCache.html","title":"PrimaAuth0Ex.JwksStrategy.EtsCache","type":"module"},{"doc":"Returns 0 - no need to fetch signers or 1 - need to fetch","ref":"PrimaAuth0Ex.JwksStrategy.EtsCache.html#check_state/0","title":"PrimaAuth0Ex.JwksStrategy.EtsCache.check_state/0","type":"function"},{"doc":"Loads fetched signers","ref":"PrimaAuth0Ex.JwksStrategy.EtsCache.html#get_signers/0","title":"PrimaAuth0Ex.JwksStrategy.EtsCache.get_signers/0","type":"function"},{"doc":"Starts ETS cache","ref":"PrimaAuth0Ex.JwksStrategy.EtsCache.html#new/0","title":"PrimaAuth0Ex.JwksStrategy.EtsCache.new/0","type":"function"},{"doc":"Puts fetched signers","ref":"PrimaAuth0Ex.JwksStrategy.EtsCache.html#put_signers/1","title":"PrimaAuth0Ex.JwksStrategy.EtsCache.put_signers/1","type":"function"},{"doc":"Sets the cache status","ref":"PrimaAuth0Ex.JwksStrategy.EtsCache.html#set_status/1","title":"PrimaAuth0Ex.JwksStrategy.EtsCache.set_status/1","type":"function"},{"doc":"Utilities to help working with prima_auth0_ex on a local environment, without the need to integrate with Auth0.","ref":"PrimaAuth0Ex.LocalToken.html","title":"PrimaAuth0Ex.LocalToken","type":"module"},{"doc":"Forge a token with the desired payload. Custom claims can be passed as keyword options. The signature will be generated locally, hence it will not be valid. For this reason, this function should be used for local development only.","ref":"PrimaAuth0Ex.LocalToken.html#forge/2","title":"PrimaAuth0Ex.LocalToken.forge/2","type":"function"},{"doc":"Generate a UNIX timestamp shifted by the given time. Can be used to quickly generate timestamps for iat and exp claims. options must be compliant to Timex.shift_options() . E.g. PrimaAuth0Ex.LocalToken.time_from_now(hours: -1) will return the UNIX timestamp for one hour ago.","ref":"PrimaAuth0Ex.LocalToken.html#time_from_now/1","title":"PrimaAuth0Ex.LocalToken.time_from_now/1","type":"function"},{"doc":"Plug to verify and validate bearer tokens Usage: plug PrimaAuth0Ex.Plug.VerifyAndValidateToken, required_permissions: [&quot;some:permission&quot;] Options The following options can be set to customize the behavior of this plug: audience: &quot;my-audience&quot; sets the expected audience. Defaults to the audience set in config.exs . required_permissions: [&quot;p1&quot;, &quot;p2&quot;] sets the set of permissions that clients are required to have. Clients who do not have all the required permissions are forbidden from accessing the API. Default is [] , ie. no permissions required, overridable from config.exs . dry_run: false when true allows clients to access the API even when their token is missing/invalid. Mostly useful for testing purposes. Default is false , overridable from config.exs . ignore_signature: false when true, validates claims found in a token without verifying its signature. Should only be enabled in dev/test environments, as it allows anyone to forge valid tokens. Default is false , overridable from config.exs .","ref":"PrimaAuth0Ex.Plug.VerifyAndValidateToken.html","title":"PrimaAuth0Ex.Plug.VerifyAndValidateToken","type":"module"},{"doc":"","ref":"PrimaAuth0Ex.Plug.VerifyAndValidateToken.html#call/2","title":"PrimaAuth0Ex.Plug.VerifyAndValidateToken.call/2","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Plug.VerifyAndValidateToken.html#init/1","title":"PrimaAuth0Ex.Plug.VerifyAndValidateToken.init/1","type":"function"},{"doc":"Module to verify the integrity and validate the claims of tokens.","ref":"PrimaAuth0Ex.Token.html","title":"PrimaAuth0Ex.Token","type":"module"},{"doc":"Combines generate_claims/1 and encode_and_sign/2","ref":"PrimaAuth0Ex.Token.html#generate_and_sign/2","title":"PrimaAuth0Ex.Token.generate_and_sign/2","type":"function"},{"doc":"Same as generate_and_sign/2 but raises if error","ref":"PrimaAuth0Ex.Token.html#generate_and_sign!/2","title":"PrimaAuth0Ex.Token.generate_and_sign!/2","type":"function"},{"doc":"Returns the list of permissions held by a token. In case of missing permissions claim or malformed token it defaults to an empty list. Note that this function does not verify the signature of the token.","ref":"PrimaAuth0Ex.Token.html#peek_permissions/1","title":"PrimaAuth0Ex.Token.peek_permissions/1","type":"function"},{"doc":"Combines verify/2 and validate/2","ref":"PrimaAuth0Ex.Token.html#verify_and_validate/3","title":"PrimaAuth0Ex.Token.verify_and_validate/3","type":"function"},{"doc":"Same as verify_and_validate/2 but raises if error","ref":"PrimaAuth0Ex.Token.html#verify_and_validate!/3","title":"PrimaAuth0Ex.Token.verify_and_validate!/3","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Token.html#verify_and_validate_token/4","title":"PrimaAuth0Ex.Token.verify_and_validate_token/4","type":"function"},{"doc":"GenServer that handles the storage and refresh of tokens. Every time a token for a new audience is requested, it retrieves it either from a cache (when possible) or from an authorization provider. Then, it runs periodic checks to ensure that all tokens are still valid, and it refreshes them when necessary.","ref":"PrimaAuth0Ex.TokenProvider.html","title":"PrimaAuth0Ex.TokenProvider","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"PrimaAuth0Ex.TokenProvider.html#child_spec/1","title":"PrimaAuth0Ex.TokenProvider.child_spec/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.html#refresh_token_for/2","title":"PrimaAuth0Ex.TokenProvider.refresh_token_for/2","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.html#start_link/1","title":"PrimaAuth0Ex.TokenProvider.start_link/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.html#token_for/2","title":"PrimaAuth0Ex.TokenProvider.token_for/2","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.html#t:t/0","title":"PrimaAuth0Ex.TokenProvider.t/0","type":"type"},{"doc":"Implementation of PrimaAuth0Ex.TokenProvider.AuthorizationService for Auth0.","ref":"PrimaAuth0Ex.TokenProvider.Auth0AuthorizationService.html","title":"PrimaAuth0Ex.TokenProvider.Auth0AuthorizationService","type":"module"},{"doc":"Fetches key ids (aka kid s) from Auth0 JWKS","ref":"PrimaAuth0Ex.TokenProvider.Auth0JwksKidsFetcher.html","title":"PrimaAuth0Ex.TokenProvider.Auth0JwksKidsFetcher","type":"module"},{"doc":"Behaviour to handle communications with an authorization service.","ref":"PrimaAuth0Ex.TokenProvider.AuthorizationService.html","title":"PrimaAuth0Ex.TokenProvider.AuthorizationService","type":"behaviour"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.AuthorizationService.html#c:retrieve_token/2","title":"PrimaAuth0Ex.TokenProvider.AuthorizationService.retrieve_token/2","type":"callback"},{"doc":"Implementation of PrimaAuth0Ex.TokenProvider.TokenService that caches tokens on an external cache in order to limit the requests made to Auth0 by reusing tokens. The external cache can be shared among different instances of the same service: in that case, when one of the instances refreshes the token and updates the shared cache, the other instances will retrieve the new token from the new cache and will not have to generate a new one from the authorization provider.","ref":"PrimaAuth0Ex.TokenProvider.CachedTokenService.html","title":"PrimaAuth0Ex.TokenProvider.CachedTokenService","type":"module"},{"doc":"Implementation of PrimaAuth0Ex.TokenProvider.TokenCache that persists encrypted copies of tokens on Redis. Encryption-related functionalities are implemented in PrimaAuth0Ex.TokenProvider.TokenEncryptor .","ref":"PrimaAuth0Ex.TokenProvider.EncryptedRedisTokenCache.html","title":"PrimaAuth0Ex.TokenProvider.EncryptedRedisTokenCache","type":"module"},{"doc":"Behaviour to fetch key ids (aka kid s) from a JWKS server","ref":"PrimaAuth0Ex.TokenProvider.JwksKidsFetcher.html","title":"PrimaAuth0Ex.TokenProvider.JwksKidsFetcher","type":"behaviour"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.JwksKidsFetcher.html#c:fetch_kids/1","title":"PrimaAuth0Ex.TokenProvider.JwksKidsFetcher.fetch_kids/1","type":"callback"},{"doc":"Implementation of PrimaAuth0Ex.TokenProvider.RefreshStrategy that relies on a probabilistic approach to decide whether to refresh a token. The reason why a probabilistic approach is desirable is that multiple instances may share a common cache of tokens. If all of them used the same deterministic approach to decide when to refresh tokens, the likelihood of concurrent regeneration of the cached token would be higher. This strategy defines a &quot;refresh window&quot;, which is a time span in the lifespan of a token when the refresh may happen (e.g., &quot;from 50% to 75% of the life of the token&quot;). The refresh time will be a random time in the refresh window. The &quot;refresh window&quot; can be customized from config as follows config :prima_auth0_ex, :client, min_token_duration : 0.5 , max_token_duration : 0.75 ,","ref":"PrimaAuth0Ex.TokenProvider.ProbabilisticRefreshStrategy.html","title":"PrimaAuth0Ex.TokenProvider.ProbabilisticRefreshStrategy","type":"module"},{"doc":"Behaviour to define a strategy to decide whether to refresh a token or keep using it for some more time.","ref":"PrimaAuth0Ex.TokenProvider.RefreshStrategy.html","title":"PrimaAuth0Ex.TokenProvider.RefreshStrategy","type":"behaviour"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.RefreshStrategy.html#c:refresh_time_for/1","title":"PrimaAuth0Ex.TokenProvider.RefreshStrategy.refresh_time_for/1","type":"callback"},{"doc":"Behaviour that defines a cache for tokens.","ref":"PrimaAuth0Ex.TokenProvider.TokenCache.html","title":"PrimaAuth0Ex.TokenProvider.TokenCache","type":"behaviour"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.TokenCache.html#c:get_token_for/1","title":"PrimaAuth0Ex.TokenProvider.TokenCache.get_token_for/1","type":"callback"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.TokenCache.html#c:set_token_for/2","title":"PrimaAuth0Ex.TokenProvider.TokenCache.set_token_for/2","type":"callback"},{"doc":"Module to perform authenticated symmetric encryption of binaries. The key used for encryption is set from config: config :prima_auth0_ex, :client, cache_encryption_key : &quot;uhOrqKvUi9gHnmwr60P2E1hiCSD2dtXK1i6dqkU4RTA=&quot;","ref":"PrimaAuth0Ex.TokenProvider.TokenEncryptor.html","title":"PrimaAuth0Ex.TokenProvider.TokenEncryptor","type":"module"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.TokenEncryptor.html#decrypt/1","title":"PrimaAuth0Ex.TokenProvider.TokenEncryptor.decrypt/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.TokenEncryptor.html#encrypt/1","title":"PrimaAuth0Ex.TokenProvider.TokenEncryptor.encrypt/1","type":"function"},{"doc":"Information related to a JWT, including the JWT itself and additional metadata","ref":"PrimaAuth0Ex.TokenProvider.TokenInfo.html","title":"PrimaAuth0Ex.TokenProvider.TokenInfo","type":"module"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.TokenInfo.html#from_jwt/1","title":"PrimaAuth0Ex.TokenProvider.TokenInfo.from_jwt/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.TokenInfo.html#t:t/0","title":"PrimaAuth0Ex.TokenProvider.TokenInfo.t/0","type":"type"},{"doc":"Behaviour to deal with retrieval and refresh of tokens","ref":"PrimaAuth0Ex.TokenProvider.TokenService.html","title":"PrimaAuth0Ex.TokenProvider.TokenService","type":"behaviour"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.TokenService.html#c:refresh_token/4","title":"PrimaAuth0Ex.TokenProvider.TokenService.refresh_token/4","type":"callback"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.TokenService.html#c:retrieve_token/2","title":"PrimaAuth0Ex.TokenProvider.TokenService.retrieve_token/2","type":"callback"},{"doc":"Copyright (c) 2020 Prima.it Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"An easy to use library to authenticate machine-to-machine communications through Auth0. Supports both retrieval of JWTs and their verification and validation.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"The package can be installed by adding prima_auth0_ex to your list of dependencies in mix.exs : def deps do [ { :prima_auth0_ex , &quot;~&gt; 0.3.0&quot; } ] end Configuration prima_auth0_ex can be configured to be used for an API consumer, an API provider or both. API Consumer To configure the library for use from a client (ie. a service that needs to obtain tokens to access some API), the following configuration is supported: config :prima_auth0_ex , # Base url for Auth0 API auth0_base_url : &quot;https://tenant.eu.auth0.com&quot; config :prima_auth0_ex , :client , # Credentials on Auth0 client_id : &quot;&quot; , client_secret : &quot;&quot; , # Enables cache on redis for tokens obtained from Auth0. Defaults to true. cache_enabled : true , # Namespace for tokens of this service on the shared cache. Should be unique per service (e.g., the service name) cache_namespace : &quot;my-service&quot; , # AES 256 key used to encrypt tokens on the shared cache. # Can be generated via `:crypto.strong_rand_bytes(32) |&gt; Base.encode64()`. cache_encryption_key : &quot;uhOrqKvUi9gHnmwr60P2E1hiCSD2dtXK1i6dqkU4RTA=&quot; , redis_connection_uri : &quot;redis://redis:6379&quot; If the client will access APIs that perform validation of permissions, make sure that the API on Auth0 is configured to have both &quot;Enable RBAC&quot; and &quot;Add Permissions in the Access Token&quot; enabled. Otherwise, the JWTs generated by Auth0 may not include the necessary permissions claims. A visualization of the logic behind the TokenProvider is available here . API Provider To configure the library for use from a server (ie. a service that exposes an API), the following configuration is supported: config :prima_auth0_ex , # Base url for Auth0 API auth0_base_url : &quot;https://tenant.eu.auth0.com&quot; config :prima_auth0_ex , :server , # Default audience used to verify tokens. Not necessary when audience is set explicitly on usage. audience : &quot;audience&quot; , # Issuer used to verify tokens. Can be found at https://your-tenant.eu.auth0.com/.well-known/openid-configuration issuer : &quot;https://tenant.eu.auth0.com/&quot; , # Whether to perform the first retrieval of JWKS synchronously. Defaults to true. first_jwks_fetch_sync : true , # When true, logs errors in validation of tokens, but it does not stop the request when the token is not valid. # Defaults to false. dry_run : false , # When true, only the claims of tokens are validated, but their signature is not verified. # This is useful for local development but should NEVER be enabled on production-like systems. # Defaults to false. ignore_signature : false","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Obtaining tokens Tokens for a given audience can be obtained as follows: { :ok , token } = PrimaAuth0Ex . token_for ( &quot;target-audience&quot; ) Tokens are automatically refreshed when they expire and when the signing keys are revoked. It is also possible to force the refresh of the token, both on the local instance and on the shared cache, as follows: { :ok , new_token } = PrimaAuth0Ex . refresh_token_for ( &quot;target-audience&quot; ) A use-case for forcing the refresh of the token may be e.g., if new permissions are added to an application on Auth0, and we want to propagate this change without waiting for the natural expiration of tokens. Verifying tokens Tokens can be verified and validated as follows: { :ok , claims } = PrimaAuth0Ex . verify_and_validate ( &quot;my-token&quot; ) The audience and the required permissions can be explicitly specified: { :ok , claims } = PrimaAuth0Ex . verify_and_validate ( &quot;my-token&quot; , &quot;my-audience&quot; , [ &quot;required-permission1&quot; ] ) For Plug -based applications, a plug to automate this process is available: plug PrimaAuth0Ex.Plug.VerifyAndValidateToken This will return 401 Forbidden to requests without a valid bearer token. The plug supports the following options: audience: &quot;my-audience&quot; to explicitly set the expected audience. When not defined it defaults to the audience configured in :prima_auth0_ex, :server, :audience ; required_permissions: [&quot;p1&quot;, &quot;p2&quot;] to forbid access to users who do not have all the required permissions; dry_run to allow access to the API when the token is not valid (mostly useful for testing purposes). Validating permissions with Absinthe In order to validate permissions in your Graphql API on a per-query/per-mutation basis, an option is to define an Absinthe middleware. It is important to note that in the following example we will only validate permissions: the other validations and the verification of the signature will still need to be done elsewhere (eg., using the aforementioned plug). First you'll need to pass the user's permissions to the Absinthe context. This can be done with a Plug like this: defmodule ExampleWeb.Graphql.Context do def init ( opts ) , do : opts def call ( conn , _ ) do permissions = case Plug.Conn . get_req_header ( conn , &quot;authorization&quot; ) do [ &quot;Bearer &quot; &lt;&gt; token ] -&gt; PrimaAuth0Ex.Token . peek_permissions ( token ) _ -&gt; [ ] end Absinthe.Plug . put_options ( conn , context : %{ permissions : permissions } ) end end Then you can define an Absinthe Middleware that validates the required permissions, as follows: defmodule Example.Graphql.Middleware.RequirePermission do @behaviour Absinthe.Middleware def call ( resolution , permission ) do if permission in resolution . context [ :permissions ] do resolution else Absinthe.Resolution . put_result ( resolution , { :error , &quot;unauthorized&quot; } ) end end end This middleware can then be used in your schema as follows: field ... do middleware RequirePermission , &quot;your-required-permission&quot; resolve &amp; Resolver . resolve_function / 3 end","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"The test suite can be executed as follows: mix test By default tests that integrate with Auth0 are excluded. To run them, configure your auth0 credentials and audience in config/test.exs and run: mix test --include external Always run formatter, linter and dialyzer before pushing changes: mix check","ref":"readme.html#development","title":"Overview - Development","type":"extras"}]